> ## Documentation Index
> Fetch the complete documentation index at: https://developer.pdf.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Parse Document

> Extract fields, tables, and values from PDFs and images using Document Parser templates with searchable form fields and multi-page support.

## `POST /v1/pdf/documentparser`

<Note>Please refer to the [Document Parser Template Editor](https://app.pdf.co/document-parser/templates) and [PDF.co Document Parser: Template Creation Guide](/knowledgebase/document-parser-guide#document-parser-template-objects-guide) for more information.</Note>

## Attributes

<Note>Attributes are case-sensitive and should be inside JSON for POST request. for example: `{ "url": "https://example.com/file1.pdf" }`</Note>

| Attribute | Type | Required | Default | Description |
| - | - | - | - | - |
| `url` | string | *Yes* | - | URL to the source file [`url` attribute](/api/url-input-and-request-limits#supported-file-sources) |
| `callback` | string | *No* | - | The callback URL (or Webhook) used to receive the POST data. see [Webhooks & Callbacks](/api/webhooks). This is only applicable when `async` is set to `true`. |
| `httpusername` | string | *No* | - | HTTP auth user name if required to access source URL. |
| `httppassword` | string | *No* | - | HTTP auth password if required to access source URL. |
| `templateId` | integer | *No* | - | Set ID of document parser template to be used. View and manage your templates at [Document Parser](https://app.pdf.co/document-parser/templates) |
| `template` | string | *No* | - | The raw format of the document parser template to be used directly. see [Template](/api/documentparser/parser) |
| `password` | string | *No* | - | Password for the PDF file. |
| `inline` | boolean | *No* | `false` | Set to true to include the results directly in the response, in addition to providing a URL to the generated output file. Applies only when `async` mode is enabled. |
| `async` | boolean | *No* | `false` | Set `async` to `true` for long processes to run in the background, API will then return a `jobId` which you can use with the [Background Job Check endpoint](/api/job-check). Also see [Webhooks & Callbacks](/api/webhooks) |
| `pages` | string | *No* | all pages | Specify page indices as comma-separated values or ranges to process (e.g. "0, 1, 2-" or "1, 2, 3-7"). The first-page index is 0. Use "!" before a number for inverted page numbers (e.g. "!0" for the last page). If not specified, the default configuration processes all pages. The input must be in string format. |
| `name` | string | *No* | - | File name for the generated output, the input must be in string format. |
| `expiration` | integer | *No* | `60` | Set the expiration time for the output link in minutes. After this specified duration, any generated output file(s) will be automatically deleted from [PDF.co Temporary Files Storage](/api/file-upload/overview). The maximum duration for link expiration varies based on your current subscription plan. To store permanent input files (e.g. re-usable images, pdf templates, documents) consider using [PDF.co Built-In Files Storage](https://app.pdf.co/tools/files). |
| `outputFormat` | string | *No* | `JSON` | The format of the output file. The output format can be `JSON`, `CSV`, or `XML`. |
| `profiles` | object | *No* | - | See [Profiles](/api/profiles) for more information. |
|     `DataEncryptionAlgorithm` | string | *No* | - | Controls the encryption algorithm used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`. |
|     `DataEncryptionKey` | string | *No* | - | Controls the encryption key used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. |
|     `DataEncryptionIV` | string | *No* | - | Controls the encryption IV used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. |
|     `DataDecryptionAlgorithm` | string | *No* | - | Controls the decryption algorithm used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`. |
|     `DataDecryptionKey` | string | *No* | - | Controls the decryption key used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. |
|     `DataDecryptionIV` | string | *No* | - | Controls the decryption IV used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. |

## Query parameters

*No query parameters accepted.*

## Responses

| Parameter | Type | Description |
| - | - | - |
| `pageCount` | integer | Number of pages in the PDF document. |
| `error` | boolean | Indicates whether an error occurred (`false` means success) |
| `status` | string | Status code of the request (200, 404, 500, etc.). For more information, see [Response Codes](/api/response-codes). |
| `credits` | integer | Number of credits consumed by the request |
| `remainingCredits` | integer | Number of credits remaining in the account |
| `duration` | integer | Time taken for the operation in milliseconds |
| `body` | object | *No* |
|     `objects` | array\[object] | |
|     `elapsed` | float | Processing time in seconds |
|     `templateName` | string | Name of the parsing template used |
|     `templateVersion` | string | Version of the parsing template |
|     `timestamp` | string | Timestamp when the parsing occurred |

## `Example` Payload

<Note>To see the request size limits, please refer to the [Request Size Limits](/api/url-input-and-request-limits#pdf-co-request-size).</Note>

```json theme={null}
{
  "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/document-parser/sample-invoice.pdf",
  "outputFormat": "JSON",
  "templateId": "1",
  "async": false,
  "inline": "true",
  "password": "",
  "profiles": ""
}
```

## `Example` Response

<Note>To see the main response codes, please refer to the [Response Codes](/api/response-codes) page.</Note>

```json theme={null}
{
  "body": {
    "objects": [
      {
        "name": "companyName",
        "objectType": "field",
        "value": "Amazon Web Services, Inc",
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "companyName2",
        "objectType": "field",
        "value": "Amazon Web Services, Inc",
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "invoiceId",
        "objectType": "field",
        "value": "123456789",
        "pageIndex": 0,
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "dateIssued",
        "objectType": "field",
        "value": "2018-04-03T00:00:00",
        "pageIndex": 0,
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "dateDue",
        "objectType": "field",
        "value": "2018-04-03T00:00:00",
        "pageIndex": 0,
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "bankAccount",
        "objectType": "field",
        "value": "123456789012",
        "pageIndex": 0,
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "total",
        "objectType": "field",
        "value": 6.58,
        "pageIndex": 0,
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "name": "subTotal",
        "objectType": "field",
        "value": ""
      },
      {
        "name": "tax",
        "objectType": "field",
        "value": 1.01,
        "pageIndex": 0,
        "rectangle": [
          0,
          0,
          0,
          0
        ]
      },
      {
        "objectType": "table",
        "name": "table",
        "rows": []
      }
    ],
    "templateName": "Generic Invoice [en]",
    "templateVersion": "4",
    "timestamp": "2020-08-21T19:23:31"
  },
  "pageCount": 1,
  "error": false,
  "status": 200,
  "name": "sample-invoice.json",
  "remainingCredits": 60803
}
```

<Note>
  **Inconsistent URL Encoding in cURL Output:** When using cURL to make API requests, the output JSON may show URL characters encoded as Unicode escape sequences. For example, the ampersand character (`&`) may appear as `\u0026` in the cURL output. This is normal JSON encoding behavior and does not affect the validity of the URL. The URL will function correctly when used, as JSON parsers automatically decode these escape sequences. If you're parsing the response programmatically, your JSON parser will handle this conversion automatically.
</Note>

## Code Samples

<Tabs>
  <Tab title="CURL">
    ```bash theme={null}
    curl --location --request POST 'https://api.pdf.co/v1/pdf/documentparser' \
    --header 'Content-Type: application/json' \
    --header 'x-api-key: {{x-api-key}}' \
    --data-raw '{
    "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/document-parser/sample-invoice.pdf",
    "outputFormat": "JSON",
    "templateId": "1",
    "async": false,
    "inline": "true",
    "password": "",
    "profiles": ""
    }'
    ```
  </Tab>

  <Tab title="JavaScript/Node.js">
    ```javascript theme={null}
    var https = require("https");
    var path = require("path");
    var fs = require("fs");

    // `request` module is required for file upload.
    // Use "npm install request" command to install.
    var request = require("request");

    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    const API_KEY = "***********************************";

    // Source PDF file
    const SourceFile = "./MultiPageTable.pdf";
    // Document Parser template file
    const TemplateFile = "./MultiPageTable-template1.yml";
    // PDF document password. Leave empty for unprotected documents.
    const Password = "";
    // The format of the output file. The output format can be JSON, CSV, or XML.
    const OutputFormat = "JSON";
    // Destination JSON file name
    const DestinationFile = "./result.json";

    // Template text. Use Document Parser (https://pdf.co/document-parser, https://app.pdf.co/document-parser)
    // to create templates.
    // Read template from file:
    const Template = fs.readFileSync(TemplateFile, "utf8");


    // 1. RETRIEVE PRESIGNED URL TO UPLOAD FILE.
    getPresignedUrl(API_KEY, SourceFile)
        .then(([uploadUrl, uploadedFileUrl]) => {
            // 2. UPLOAD THE FILE TO CLOUD.
            uploadFile(API_KEY, SourceFile, uploadUrl)
                .then(() => {
                    // 3. PARSE UPLOADED PDF DOCUMENT
                    parseDocument(API_KEY, uploadedFileUrl, Template, Password, OutputFormat, DestinationFile);
                })
                .catch(e => {
                    console.log(e);
                });
        })
        .catch(e => {
            console.log(e);
        });


    function getPresignedUrl(apiKey, localFile) {
        return new Promise(resolve => {
            // Prepare request to `Get Presigned URL` API endpoint
            let queryPath = `/v1/file/upload/get-presigned-url?contenttype=application/octet-stream&name=${path.basename(localFile)}`;
            let reqOptions = {
                host: "api.pdf.co",
                path: encodeURI(queryPath),
                headers: { "x-api-key": API_KEY }
            };
            // Send request
            https.get(reqOptions, (response) => {
                response.on("data", (d) => {
                    let data = JSON.parse(d);
                    if (data.error == false) {
                        // Return presigned url we received
                        resolve([data.presignedUrl, data.url]);
                    }
                    else {
                        // Service reported error
                        console.log("getPresignedUrl(): " + data.message);
                    }
                });
            })
                .on("error", (e) => {
                    // Request error
                    console.log("getPresignedUrl(): " + e);
                });
        });
    }

    function uploadFile(apiKey, localFile, uploadUrl) {
        return new Promise(resolve => {
            fs.readFile(localFile, (err, data) => {
                request({
                    method: "PUT",
                    url: uploadUrl,
                    body: data,
                    headers: {
                        "Content-Type": "application/octet-stream"
                    }
                }, (err, res, body) => {
                    if (!err) {
                        resolve();
                    }
                    else {
                        console.log("uploadFile() request error: " + err);
                    }
                });
            });
        });
    }

    function parseDocument(apiKey, uploadedFileUrl, template, password, outputFormat, destinationFile) {
        // Prepare request to `Document Parser` API endpoint
        var queryPath = `/v1/pdf/documentparser`;

        // JSON payload for api request
        var jsonPayload = JSON.stringify({
            url: uploadedFileUrl,
            template: template,
            password: password,
            outputFormat: outputFormat,
            name: path.basename(destinationFile)
        });

        var reqOptions = {
            host: "api.pdf.co",
            method: "POST",
            path: queryPath,
            headers: {
                "x-api-key": apiKey,
                "Content-Type": "application/json",
                "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
            }
        };
        // Send request
        var postRequest = https.request(reqOptions, (response) => {
            response.on("data", (d) => {
                response.setEncoding("utf8");
                // Parse JSON response
                let data = JSON.parse(d);
                if (data.error == false) {
                    // Download JSON file
                    var file = fs.createWriteStream(destinationFile);
                    https.get(data.url, (response2) => {
                        response2.pipe(file)
                            .on("close", () => {
                                console.log(`Generated JSON file saved as "${destinationFile}" file.`);
                            });
                    });
                }
                else {
                    // Service reported error
                    console.log("parseDocument(): " + data.message);
                }
            });
        })
            .on("error", (e) => {
                // Request error
                console.log("parseDocument(): " + e);
            });

        // Write request data
        postRequest.write(jsonPayload);
        postRequest.end();
    }
    ```
  </Tab>

  <Tab title="Python">
    ```python theme={null}
    import os
    import requests # pip install requests

    # The authentication key (API Key).
    # Get your own by registering at https://app.pdf.co
    API_KEY = "*************************************"

    # Base URL for PDF.co Web API requests
    BASE_URL = "https://api.pdf.co/v1"

    # Source PDF file
    SourceFile = ".\\MultiPageTable.pdf"
    # Document Parser template file
    TemplateFile = ".\\MultiPageTable-template1.yml"
    # PDF document password. Leave empty for unprotected documents.
    Password = ""
    # The format of the output file. The output format can be JSON, CSV, or XML.
    OutputFormat = "JSON"
    # Destination JSON file name
    DestinationFile = ".\\result.json"

    # Template text. Use Document Parser (https://pdf.co/document-parser, https://app.pdf.co/document-parser)
    # to create templates.
    # Read template from file:
    file_read = open(TemplateFile, mode='r', encoding="utf-8", errors="ignore")
    Template = file_read.read()
    file_read.close()


    def main(args = None):
        uploadedFileUrl = uploadFile(SourceFile)
        if (uploadedFileUrl != None):
            PerformDocumentParser(uploadedFileUrl, Template, DestinationFile)


    def PerformDocumentParser(uploadedFileUrl, template, destinationFile):
        """Parses a document using PDF.co Web API"""

        # Prepare requests params as JSON
        # See documentation: https://developer.pdf.co/
        parameters = {}
        parameters["url"] = uploadedFileUrl
        parameters["template"] = template
        parameters["password"] = Password
        parameters["outputFormat"] = OutputFormat
        parameters["name"] = os.path.basename(destinationFile)

        # Prepare URL for 'Document Parser' API request
        url = "{}/pdf/documentparser".format(BASE_URL)

        # Execute request and get response as JSON
        response = requests.post(url, data=parameters, headers={ "x-api-key": API_KEY })
        if (response.status_code == 200):
            json = response.json()

            if json["error"] == False:
                #  Get URL of result file
                resultFileUrl = json["url"]
                # Download result file
                r = requests.get(resultFileUrl, stream=True)
                if (r.status_code == 200):
                    with open(destinationFile, 'wb') as file:
                        for chunk in r:
                            file.write(chunk)
                    print(f"Result file saved as \"{destinationFile}\" file.")
                else:
                    print(f"Request error: {response.status_code} {response.reason}")
            else:
                # Show service reported error
                print(json["message"])
        else:
            print(f"Request error: {response.status_code} {response.reason}")


    def uploadFile(fileName):
        """Uploads file to the cloud"""

        # 1. RETRIEVE PRESIGNED URL TO UPLOAD FILE.

        # Prepare URL for 'Get Presigned URL' API request
        url = "{}/file/upload/get-presigned-url?contenttype=application/octet-stream&name={}".format(
            BASE_URL, os.path.basename(fileName))

        # Execute request and get response as JSON
        response = requests.get(url, headers={ "x-api-key": API_KEY })
        if (response.status_code == 200):
            json = response.json()

            if json["error"] == False:
                # URL to use for file upload
                uploadUrl = json["presignedUrl"]
                # URL for future reference
                uploadedFileUrl = json["url"]

                # 2. UPLOAD FILE TO CLOUD.
                with open(fileName, 'rb') as file:
                    requests.put(uploadUrl, data=file, headers={ "x-api-key": API_KEY, "content-type": "application/octet-stream" })

                return uploadedFileUrl
            else:
                # Show service reported error
                print(json["message"])
        else:
            print(f"Request error: {response.status_code} {response.reason}")

        return None


    if __name__ == '__main__':
        main()
    ```
  </Tab>

  <Tab title="C#">
    ```csharp theme={null}
    using Newtonsoft.Json;
      using Newtonsoft.Json.Linq;
      using System;
      using System.Collections.Generic;
      using System.IO;
      using System.Net;

      namespace PDFcoApiExample
      {
          class Program
          {
              // The authentication key (API Key).
              // Get your own by registering at https://app.pdf.co
              const String API_KEY = "***********************************";

              // Source PDF file
              const string SourceFile = @".\MultiPageTable.pdf";
              // PDF document password. Leave empty for unprotected documents.
              const string Password = "";
              // Destination TXT file name
              const string DestinationFile = @".\result.json";

              static void Main(string[] args)
              {
                  // Template text. Use Document Parser (https://pdf.co/document-parser, https://app.pdf.co/document-parser)
                  // to create templates.
                  // Read template from file:
                  String templateText = File.ReadAllText(@".\MultiPageTable-template1.yml");

                  // Create standard .NET web client instance
                  WebClient webClient = new WebClient();

                  // Set API Key
                  webClient.Headers.Add("x-api-key", API_KEY);

                  // 1. RETRIEVE THE PRESIGNED URL TO UPLOAD THE FILE.
                  // * If you already have a direct file URL, skip to the step 3.

                  // Prepare URL for `Get Presigned URL` API call
                  string query = Uri.EscapeUriString(string.Format(
                      "https://api.pdf.co/v1/file/upload/get-presigned-url?contenttype=application/octet-stream&name={0}",
                      Path.GetFileName(SourceFile)));

                  try
                  {
                      // Execute request
                      string response = webClient.DownloadString(query);

                      // Parse JSON response
                      JObject json = JObject.Parse(response);

                      if (json["error"].ToObject<bool>() == false)
                      {
                          // Get URL to use for the file upload
                          string uploadUrl = json["presignedUrl"].ToString();
                          string uploadedFileUrl = json["url"].ToString();

                          // 2. UPLOAD THE FILE TO CLOUD.

                          webClient.Headers.Add("content-type", "application/octet-stream");
                          webClient.UploadFile(uploadUrl, "PUT", SourceFile); // You can use UploadData() instead if your file is byte[] or Stream
                          webClient.Headers.Remove("content-type");

                          // 3. PARSE UPLOADED PDF DOCUMENT

                          // URL of `Document Parser` API call
                          string url = "https://api.pdf.co/v1/pdf/documentparser";

                          Dictionary<string, string> requestBody = new Dictionary<string, string>();
                          requestBody.Add("template", templateText);
                          requestBody.Add("name", Path.GetFileName(DestinationFile));
                          requestBody.Add("url", uploadedFileUrl);

                          // Convert dictionary of params to JSON
                          string jsonPayload = JsonConvert.SerializeObject(requestBody);

                          // Execute request
                          response = webClient.UploadString(url, "POST", jsonPayload);

                          // Parse response
                          json = JObject.Parse(response);

                          if (json["error"].ToObject<bool>() == false)
                          {
                              // Get URL of generated JSON file
                              string resultFileUrl = json["url"].ToString();

                              // Download JSON file
                              webClient.DownloadFile(resultFileUrl, DestinationFile);

                              Console.WriteLine("Generated JSON file saved as \"{0}\" file.", DestinationFile);
                          }
                          else
                          {
                              Console.WriteLine(json["message"].ToString());
                          }
                      }
                      else
                      {
                          Console.WriteLine(json["message"].ToString());
                      }
                  }
                  catch (WebException e)
                  {
                      Console.WriteLine(e.ToString());
                  }

                  webClient.Dispose();

                  Console.WriteLine();
                  Console.WriteLine("Press any key...");
                  Console.ReadKey();
              }
          }
      }
    ```
  </Tab>

  <Tab title="Java">
    ```java theme={null}
    package com.company;

      import com.google.gson.JsonObject;
      import com.google.gson.JsonParser;
      import com.google.gson.JsonPrimitive;
      import okhttp3.*;

      import java.io.File;
      import java.io.FileOutputStream;
      import java.io.IOException;
      import java.io.OutputStream;
      import java.nio.charset.StandardCharsets;
      import java.nio.file.Files;
      import java.nio.file.Path;
      import java.nio.file.Paths;

      public class Main
      {
          // The authentication key (API Key).
          // Get your own by registering at https://app.pdf.co
          final static String API_KEY = "***********************************";

          public static void main(String[] args) throws IOException
          {
              // Source PDF file
              final Path SourceFile = Paths.get(".\\MultiPageTable.pdf");
              // PDF document password. Leave empty for unprotected documents.
              final String Password = "";
              // Destination JSON file name
              final Path DestinationFile = Paths.get(".\\result.json");

              // Template text. Use Document Parser (https://pdf.co/document-parser, https://app.pdf.co/document-parser)
              // to create templates.
              // Read template from file:
              String templateText = new String(Files.readAllBytes(Paths.get(".\\MultiPageTable-template1.yml")), StandardCharsets.UTF_8);

              // Create HTTP client instance
              OkHttpClient webClient = new OkHttpClient();

              // 1. RETRIEVE THE PRESIGNED URL TO UPLOAD THE FILE.
              // * If you already have a direct file URL, skip to the step 3.

              // Prepare URL for `Get Presigned URL` API call
              String query = String.format(
                      "https://api.pdf.co/v1/file/upload/get-presigned-url?contenttype=application/octet-stream&name=%s",
                      SourceFile.getFileName());

              // Prepare request
              Request request = new Request.Builder()
                      .url(query)
                      .addHeader("x-api-key", API_KEY) // (!) Set API Key
                      .build();
              // Execute request
              Response response = webClient.newCall(request).execute();

              if (response.code() == 200)
              {
                  // Parse JSON response
                  JsonObject json = new JsonParser().parse(response.body().string()).getAsJsonObject();

                  boolean error = json.get("error").getAsBoolean();
                  if (!error)
                  {
                      // Get URL to use for the file upload
                      String uploadUrl = json.get("presignedUrl").getAsString();
                      // Get URL of uploaded file to use with later API calls
                      String uploadedFileUrl = json.get("url").getAsString();

                      // 2. UPLOAD THE FILE TO CLOUD.

                      if (uploadFile(webClient, API_KEY, uploadUrl, SourceFile))
                      {
                          // 3. PARSE UPLOADED PDF DOCUMENT

                          ParseDocument(webClient, API_KEY, DestinationFile, Password, uploadedFileUrl, templateText);
                      }
                  }
                  else
                  {
                      // Display service reported error
                      System.out.println(json.get("message").getAsString());
                  }
              }
              else
              {
                  // Display request error
                  System.out.println(response.code() + " " + response.message());
              }
          }

          public static void ParseDocument(OkHttpClient webClient, String apiKey, Path destinationFile,
              String password, String uploadedFileUrl, String templateText) throws IOException
          {
              // Prepare POST request body in JSON format
              JsonObject jsonBody = new JsonObject();
              jsonBody.add("url", new JsonPrimitive(uploadedFileUrl));
              jsonBody.add("template", new JsonPrimitive(templateText));

              RequestBody body = RequestBody.create(MediaType.parse("application/json"), jsonBody.toString());

              // Prepare request to `Document Parser` API
              Request request = new Request.Builder()
                      .url("https://api.pdf.co/v1/pdf/documentparser")
                      .addHeader("x-api-key", API_KEY) // (!) Set API Key
                      .addHeader("Content-Type", "application/json")
                      .post(body)
                      .build();

              // Execute request
              Response response = webClient.newCall(request).execute();

              if (response.code() == 200)
              {
                  // Parse JSON response
                  JsonObject json = new JsonParser().parse(response.body().string()).getAsJsonObject();

                  boolean error = json.get("error").getAsBoolean();
                  if (!error)
                  {
                      // Get URL of generated JSON file
                      String resultFileUrl = json.get("url").getAsString();

                      // Download JSON file
                      downloadFile(webClient, resultFileUrl, destinationFile.toFile());

                      System.out.printf("Generated JSON file saved as \"%s\" file.", destinationFile.toString());
                  }
                  else
                  {
                      // Display service reported error
                      System.out.println(json.get("message").getAsString());
                  }
              }
              else
              {
                  // Display request error
                  System.out.println(response.code() + " " + response.message());
              }
          }

          public static boolean uploadFile(OkHttpClient webClient, String apiKey, String url, Path sourceFile) throws IOException
          {
              // Prepare request body
              RequestBody body = RequestBody.create(MediaType.parse("application/octet-stream"), sourceFile.toFile());

              // Prepare request
              Request request = new Request.Builder()
                      .url(url)
                      .addHeader("x-api-key", apiKey) // (!) Set API Key
                      .addHeader("content-type", "application/octet-stream")
                      .put(body)
                      .build();

              // Execute request
              Response response = webClient.newCall(request).execute();

              return (response.code() == 200);
          }

          public static void downloadFile(OkHttpClient webClient, String url, File destinationFile) throws IOException
          {
              // Prepare request
              Request request = new Request.Builder()
                      .url(url)
                      .build();
              // Execute request
              Response response = webClient.newCall(request).execute();

              byte[] fileBytes = response.body().bytes();

              // Save downloaded bytes to file
              OutputStream output = new FileOutputStream(destinationFile);
              output.write(fileBytes);
              output.flush();
              output.close();

              response.close();
          }
      }
    ```
  </Tab>

  <Tab title="PHP">
    ```php theme={null}
    <?php

    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    $API_KEY = "***********************************";

    // Source PDF file
    $SourceFile = "./MultiPageTable.pdf";
    // Document Parser template file
    $TemplateFile = "./MultiPageTable-template1.yml";
    // PDF document password. Leave empty for unprotected documents.
    $Password = "";
    // The format of the output file. The output format can be JSON, CSV, or XML.
    $OutputFormat = "JSON";
    // Destination JSON file name
    $DestinationFile = "./result.json";


    $templateText = file_get_contents($TemplateFile);

    if ($templateText === false) {
        echo "unable to read " . $TemplateFile . PHP_EOL;
    } else {
        // 1. RETRIEVE THE PRESIGNED URL TO UPLOAD THE FILE.
        // * If you already have the direct PDF file link, go to the step 3.
        $presignedUrls = getPresignedUrl($API_KEY, $SourceFile);

        if ($presignedUrls !== null) {
            list($uploadUrl, $uploadedFileUrl) = $presignedUrls;

            // 2. UPLOAD THE FILE TO CLOUD.
            if (uploadFile($API_KEY, $SourceFile, $uploadUrl)) {
                // 3. PARSE UPLOADED PDF DOCUMENT
                parseDocument($API_KEY, $uploadedFileUrl, $templateText, $Password, $OutputFormat, $DestinationFile);
            }
        }
    }


    function getPresignedUrl($apiKey, $localFile)
    {
        // Prepare URL for `Get Presigned URL` API call
        $url = "https://api.pdf.co/v1/file/upload/get-presigned-url"
            . "?contenttype=application/octet-stream"
            . "&name=" . urlencode(basename($localFile));

        // Create request
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        // Execute request
        $result = curl_exec($curl);
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $curlError = curl_error($curl);
        curl_close($curl);

        if ($result === false) {
            // Display CURL error
            echo "getPresignedUrl(): " . $curlError . PHP_EOL;
            return null;
        }

        if ($statusCode != 200) {
            // Display request error
            echo "getPresignedUrl(): request error " . $statusCode . PHP_EOL . $result . PHP_EOL;
            return null;
        }

        $json = json_decode($result, true);

        if (!empty($json["error"])) {
            // Display service reported error
            echo "getPresignedUrl(): " . $json["message"] . PHP_EOL;
            return null;
        }

        // Return the URL to use for the file upload, and the URL of the uploaded
        // file to use with later API calls
        return array($json["presignedUrl"], $json["url"]);
    }

    function uploadFile($apiKey, $localFile, $uploadUrl)
    {
        $fileHandle = fopen($localFile, "rb");

        if ($fileHandle === false) {
            echo "uploadFile(): unable to open " . $localFile . PHP_EOL;
            return false;
        }

        // Create request. The presigned URL expects a raw PUT of the file bytes.
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $uploadUrl);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "content-type: application/octet-stream"));
        curl_setopt($curl, CURLOPT_PUT, true);
        curl_setopt($curl, CURLOPT_INFILE, $fileHandle);
        curl_setopt($curl, CURLOPT_INFILESIZE, filesize($localFile));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        // Execute request
        $result = curl_exec($curl);
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $curlError = curl_error($curl);
        curl_close($curl);
        fclose($fileHandle);

        if ($result === false) {
            // Display CURL error
            echo "uploadFile(): " . $curlError . PHP_EOL;
            return false;
        }

        if ($statusCode != 200) {
            // Display request error
            echo "uploadFile(): request error " . $statusCode . PHP_EOL . $result . PHP_EOL;
            return false;
        }

        return true;
    }

    function parseDocument($apiKey, $uploadedFileUrl, $templateText, $password, $outputFormat, $destinationFile)
    {
        // Prepare URL for `Document Parser` API call
        $url = "https://api.pdf.co/v1/pdf/documentparser";

        // Prepare requests params
        $parameters = array();
        $parameters["url"] = $uploadedFileUrl;
        $parameters["template"] = $templateText;
        $parameters["password"] = $password;
        $parameters["outputFormat"] = $outputFormat;
        $parameters["name"] = basename($destinationFile);

        // Create Json payload
        $data = json_encode($parameters);

        // Create request
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-Type: application/json"));
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        // Execute request
        $result = curl_exec($curl);
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $curlError = curl_error($curl);
        curl_close($curl);

        if ($result === false) {
            // Display CURL error
            echo "parseDocument(): " . $curlError . PHP_EOL;
            return;
        }

        if ($statusCode != 200) {
            // Display request error
            echo "parseDocument(): request error " . $statusCode . PHP_EOL . $result . PHP_EOL;
            return;
        }

        $json = json_decode($result, true);

        if (!empty($json["error"])) {
            // Display service reported error
            echo "parseDocument(): " . $json["message"] . PHP_EOL;
            return;
        }

        // Get URL of generated JSON file
        $resultFileUrl = $json["url"];

        // Download JSON file
        if (downloadFile($resultFileUrl, $destinationFile)) {
            echo "Generated JSON file saved as \"" . $destinationFile . "\" file." . PHP_EOL;
        }
    }

    function downloadFile($url, $destinationFile)
    {
        // Create request
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);

        // Execute request
        $result = curl_exec($curl);
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $curlError = curl_error($curl);
        curl_close($curl);

        if ($result === false) {
            // Display CURL error
            echo "downloadFile(): " . $curlError . PHP_EOL;
            return false;
        }

        if ($statusCode != 200) {
            // Display request error
            echo "downloadFile(): request error " . $statusCode . PHP_EOL . $result . PHP_EOL;
            return false;
        }

        // Write the file only after a successful response so failures leave no file behind
        if (file_put_contents($destinationFile, $result) === false) {
            echo "downloadFile(): unable to create " . $destinationFile . PHP_EOL;
            return false;
        }

        return true;
    }

    ?>
    ```
  </Tab>
</Tabs>


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.